(* This file is generated by Why3's Coq 8.4 driver *)
(* Beware! Only edit allowed sections below    *)
Require Import BuiltIn.
Require BuiltIn.
Require int.Int.
Require list.List.
Require list.Length.
Require list.Mem.
Require map.Map.
Require list.Nth.
Require option.Option.
Require list.NthLength.
Require list.Append.
Require list.NthLengthAppend.

(* Why3 assumption *)
Definition unit := unit.

(* Why3 assumption *)
Inductive array
  (a:Type) {a_WT:WhyType a} :=
  | mk_array : Z -> (@map.Map.map Z _ a a_WT) -> array a.
Axiom array_WhyType : forall (a:Type) {a_WT:WhyType a}, WhyType (array a).
Existing Instance array_WhyType.
Implicit Arguments mk_array [[a] [a_WT]].

(* Why3 assumption *)
Definition elts {a:Type} {a_WT:WhyType a} (v:(@array a a_WT)): (@map.Map.map
  Z _ a a_WT) := match v with
  | (mk_array x x1) => x1
  end.

(* Why3 assumption *)
Definition length {a:Type} {a_WT:WhyType a} (v:(@array a a_WT)): Z :=
  match v with
  | (mk_array x x1) => x
  end.

(* Why3 assumption *)
Definition get {a:Type} {a_WT:WhyType a} (a1:(@array a a_WT)) (i:Z): a :=
  (map.Map.get (elts a1) i).

(* Why3 assumption *)
Definition set {a:Type} {a_WT:WhyType a} (a1:(@array a a_WT)) (i:Z)
  (v:a): (@array a a_WT) := (mk_array (length a1) (map.Map.set (elts a1) i
  v)).

(* Why3 assumption *)
Definition make {a:Type} {a_WT:WhyType a} (n:Z) (v:a): (@array a a_WT) :=
  (mk_array n (map.Map.const v:(@map.Map.map Z _ a a_WT))).

(* Why3 assumption *)
Inductive buffer
  (a:Type) {a_WT:WhyType a} :=
  | mk_buffer : Z -> Z -> (@array a a_WT) -> (list a) -> buffer a.
Axiom buffer_WhyType : forall (a:Type) {a_WT:WhyType a}, WhyType (buffer a).
Existing Instance buffer_WhyType.
Implicit Arguments mk_buffer [[a] [a_WT]].

(* Why3 assumption *)
Definition sequence {a:Type} {a_WT:WhyType a} (v:(@buffer
  a a_WT)): (list a) := match v with
  | (mk_buffer x x1 x2 x3) => x3
  end.

(* Why3 assumption *)
Definition data {a:Type} {a_WT:WhyType a} (v:(@buffer a a_WT)): (@array
  a a_WT) := match v with
  | (mk_buffer x x1 x2 x3) => x2
  end.

(* Why3 assumption *)
Definition len {a:Type} {a_WT:WhyType a} (v:(@buffer a a_WT)): Z :=
  match v with
  | (mk_buffer x x1 x2 x3) => x1
  end.

(* Why3 assumption *)
Definition first {a:Type} {a_WT:WhyType a} (v:(@buffer a a_WT)): Z :=
  match v with
  | (mk_buffer x x1 x2 x3) => x
  end.

(* Why3 assumption *)
Definition size {a:Type} {a_WT:WhyType a} (b:(@buffer a a_WT)): Z :=
  (length (data b)).

Require Import Why3. Ltac ae := why3 "alt-ergo" timelimit 3.

(* Why3 goal *)
Theorem WP_parameter_pop : forall {a:Type} {a_WT:WhyType a}, forall (b:Z)
  (b1:Z) (b2:Z) (b3:(@map.Map.map Z _ a a_WT)) (b4:(list a)),
  (((((0%Z <= b)%Z /\ (b < b2)%Z) /\ (((0%Z <= b1)%Z /\ (b1 <= b2)%Z) /\
  ((b1 = (list.Length.length b4)) /\ forall (i:Z), ((0%Z <= i)%Z /\
  (i < b1)%Z) -> ((((b + i)%Z < b2)%Z -> ((list.Nth.nth i
  b4) = (Some (map.Map.get b3 (b + i)%Z)))) /\
  ((0%Z <= ((b + i)%Z - b2)%Z)%Z -> ((list.Nth.nth i
  b4) = (Some (map.Map.get b3 ((b + i)%Z - b2)%Z)))))))) /\ (0%Z <= b2)%Z) /\
  (0%Z < b1)%Z) ->
  match b4 with
  | nil => True
  | (cons _ s) => forall (rho:(list a)), (rho = s) -> (((0%Z <= b)%Z /\
      (b < b2)%Z) -> forall (rho1:Z), (rho1 = (b1 - 1%Z)%Z) ->
      forall (rho2:Z), (rho2 = (b + 1%Z)%Z) -> ((~ (rho2 = b2)) ->
      ((((0%Z <= rho2)%Z /\ (rho2 < b2)%Z) /\ (((0%Z <= rho1)%Z /\
      (rho1 <= b2)%Z) /\ ((rho1 = (list.Length.length rho)) /\ forall (i:Z),
      ((0%Z <= i)%Z /\ (i < rho1)%Z) -> ((((rho2 + i)%Z < b2)%Z ->
      ((list.Nth.nth i rho) = (Some (map.Map.get b3 (rho2 + i)%Z)))) /\
      ((0%Z <= ((rho2 + i)%Z - b2)%Z)%Z -> ((list.Nth.nth i
      rho) = (Some (map.Map.get b3 ((rho2 + i)%Z - b2)%Z)))))))) ->
      match b4 with
      | nil => True
      | (cons x l) => ((map.Map.get b3 b) = x)
      end)))
  end.
(* Why3 intros a a_WT b b1 b2 b3 b4 ((((h1,h2),((h3,h4),(h5,h6))),h7),h8). *)
unfold get; simpl.
intros a a_WT b rho rho1 rho2 rho3 (((h1,(h2,(h3,h4))),_),h5).
destruct rho3; auto.
intros; subst.
generalize (h4 (0%Z)).
ae.
Qed.


